module Prepp
  class Command

    def initialize(name, *dependencies, &block)
      @name = name.to_sym
      @dependencies = *dependencies
      @execute = []
      @verifiers = []

      @results = []

      instance_eval(&block)
    end

    attr_accessor :results

    def execute(command = nil, &block)
      @execute << (block_given? ? instance_eval(&block) : command)
    end

    def verify(command = nil, &block)
      @verifiers << (block_given? ? instance_eval(&block) : command)
    end

    def to_s
      build_ssh_command
    end

    private

    def build_ssh_command
      [].tap do |cmd|
        cmd << @verifiers.join(' && ') unless @verifiers.empty?
        cmd << @execute.join(' && ') unless @execute.empty?
      end.join(' && ')
    end
  end
end
