require_relative 'commands/command'
require_relative 'target'

module Prepp
  class Recipe
    def initialize(&block)
      @commands = []
      @targets = []

      instance_eval(&block)
      execute
    end

    def package(name, *dependencies, &block)
      @commands << Command.new(name, *dependencies, &block)
    end

    def target(host, user, options={})
      @targets << Target.new(host, user, options)
    end

    private

    def execute
      @targets.each{|t| t.execute @commands }
    end
  end
end
